<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Louvain Algorithm: src/louvain.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Louvain Algorithm
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">louvain.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;stdio.h&gt;</code><br />
<code>#include &lt;stdlib.h&gt;</code><br />
<code>#include &lt;math.h&gt;</code><br />
<code>#include &lt;string.h&gt;</code><br />
<code>#include &quot;<a class="el" href="graph_8h_source.html">graph.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="community_8h_source.html">community.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for louvain.c:</div>
<div class="dyncontent">
<div class="center"><img src="louvain_8c__incl.png" border="0" usemap="#src_2louvain_8c" alt=""/></div>
<map name="src_2louvain_8c" id="src_2louvain_8c">
<area shape="rect" id="node6" href="graph_8h.html" title="graph.h" alt="" coords="337,155,402,181"/>
<area shape="rect" id="node7" href="community_8h.html" title="community.h" alt="" coords="407,80,505,107"/>
<area shape="rect" id="node8" href="linkedlist_8h.html" title="linkedlist.h" alt="" coords="426,155,510,181"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:af0f2173e3b202ddf5756531b4471dcb2"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="louvain_8c.html#af0f2173e3b202ddf5756531b4471dcb2">MAX_LINE_LENGTH</a>&#160;&#160;&#160;40</td></tr>
<tr class="separator:af0f2173e3b202ddf5756531b4471dcb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c7b069fee3c8184e14a7de8e5da2dc6"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="louvain_8c.html#a9c7b069fee3c8184e14a7de8e5da2dc6">PRECISION</a>&#160;&#160;&#160;0.000001</td></tr>
<tr class="separator:a9c7b069fee3c8184e14a7de8e5da2dc6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a0419fa6034af8b0d33326892ee87ca"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="louvain_8c.html#a8a0419fa6034af8b0d33326892ee87ca">DEF_NUM_PASS</a>&#160;&#160;&#160;-1</td></tr>
<tr class="separator:a8a0419fa6034af8b0d33326892ee87ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07e2b531c72985b064c431c05dfbc5fc"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="louvain_8c.html#a07e2b531c72985b064c431c05dfbc5fc">MAX_LINES</a>&#160;&#160;&#160;1000000</td></tr>
<tr class="separator:a07e2b531c72985b064c431c05dfbc5fc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a471b593acd03dd61f1afd3d2420bcb0f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="louvain_8c.html#a471b593acd03dd61f1afd3d2420bcb0f">comm2graph</a> (<a class="el" href="structcommunity__set__t.html">community_set_t</a> *set)</td></tr>
<tr class="separator:a471b593acd03dd61f1afd3d2420bcb0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40b9ad08a490c59031fcdbf34f4f01ae"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="louvain_8c.html#a40b9ad08a490c59031fcdbf34f4f01ae">louvain</a> (<a class="el" href="structgraph__t.html">graph_t</a> *g, int n)</td></tr>
<tr class="separator:a40b9ad08a490c59031fcdbf34f4f01ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acceef7517ade9256524d1ff2c56c4838"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="louvain_8c.html#acceef7517ade9256524d1ff2c56c4838">read_input</a> (const char *name)</td></tr>
<tr class="separator:acceef7517ade9256524d1ff2c56c4838"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ddf1224851353fc92bfbff6f499fa97"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="louvain_8c.html#a0ddf1224851353fc92bfbff6f499fa97">main</a> (int argc, char *argv[])</td></tr>
<tr class="separator:a0ddf1224851353fc92bfbff6f499fa97"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a8a0419fa6034af8b0d33326892ee87ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8a0419fa6034af8b0d33326892ee87ca">&#9670;&nbsp;</a></span>DEF_NUM_PASS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define DEF_NUM_PASS&#160;&#160;&#160;-1</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The default max number of repetitions of phase 1 before phase 2 of the algorithm </p>

</div>
</div>
<a id="af0f2173e3b202ddf5756531b4471dcb2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af0f2173e3b202ddf5756531b4471dcb2">&#9670;&nbsp;</a></span>MAX_LINE_LENGTH</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MAX_LINE_LENGTH&#160;&#160;&#160;40</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The maximum length of the input string read in the input file. </p>

</div>
</div>
<a id="a07e2b531c72985b064c431c05dfbc5fc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07e2b531c72985b064c431c05dfbc5fc">&#9670;&nbsp;</a></span>MAX_LINES</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MAX_LINES&#160;&#160;&#160;1000000</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The maximum number of lines that the input file can have </p>

</div>
</div>
<a id="a9c7b069fee3c8184e14a7de8e5da2dc6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9c7b069fee3c8184e14a7de8e5da2dc6">&#9670;&nbsp;</a></span>PRECISION</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define PRECISION&#160;&#160;&#160;0.000001</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The minimum improvement in the modularity needed to continue with the iterations </p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a471b593acd03dd61f1afd3d2420bcb0f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a471b593acd03dd61f1afd3d2420bcb0f">&#9670;&nbsp;</a></span>comm2graph()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structgraph__t.html">graph_t</a>* comm2graph </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcommunity__set__t.html">community_set_t</a> *&#160;</td>
          <td class="paramname"><em>set</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to create a graph from a set of communities, it also frees the memory allocated for the given set and the old graph. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">set</td><td>The set of communities to translate </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the new graph created </dd></dl>

</div>
</div>
<a id="a40b9ad08a490c59031fcdbf34f4f01ae"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a40b9ad08a490c59031fcdbf34f4f01ae">&#9670;&nbsp;</a></span>louvain()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structgraph__t.html">graph_t</a>* louvain </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structgraph__t.html">graph_t</a> *&#160;</td>
          <td class="paramname"><em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function that implements the Louvain algorithm for community detection, it is divided into two phases that are repeated iteratively until there can't be an improvement in modularity. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">g</td><td>The given initial graph to start the modularity optimization. </td></tr>
    <tr><td class="paramname">n</td><td>The number of passes to be done in phase 1 before moving to phase 2. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to a graph containing the optimized network. Communities are now represented by nodes and arches between them represent connections between communities. </dd></dl>

</div>
</div>
<a id="a0ddf1224851353fc92bfbff6f499fa97"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0ddf1224851353fc92bfbff6f499fa97">&#9670;&nbsp;</a></span>main()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int main </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>argc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>argv</em>[]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="acceef7517ade9256524d1ff2c56c4838"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acceef7517ade9256524d1ff2c56c4838">&#9670;&nbsp;</a></span>read_input()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structgraph__t.html">graph_t</a>* read_input </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Function to create a graph from an input file containing the nodes of the community stored as pairs source-destination </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The input file's name. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the created graph. </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
